/* stripped version of modify.cmd */
Call RxFuncAdd 'SysLoadFuncs','REXXUTIL','SysLoadFuncs'
Call SysLoadFuncs;
call Logo
esc          = x2c('1B')
Color.cyan   = esc'[1;36;40m'
Color.white  = esc'[0;37;40m'
Color.red    = esc'[1;31;40m'
Color.yellow = esc'[1;33;40m'
Color.green  = esc'[1;32;40m'
Color.grey   = esc'[1;30;40m'
Command.0 = 7
Command.1 = 'OPEN  O'
Command.2 = 'CLOSE C'
Command.3 = 'ADD   A'
Command.4 = 'DEL   DELETE D'
Command.5 = 'REP   REPLACE R MODIFY MOD M'
Command.6 = 'SAV   SAVE S'
Command.7 = 'REX   REXX'
Option.0  = 16
Option.1  = 'ATB  ATBEGIN'
Option.2  = 'ATB  ATBEGIN'
Option.3  = 'ATE  ATEND'
Option.4  = 'AFT  AFTER'
Option.5  = 'BEF  BEFORE'
Option.6  = 'NOX  NOXP NOPIFEXIST NOPIFEXISTATPOSITION'
Option.7  = 'NOXS NOPIFEXISTINSECTION'
Option.8  = 'NOXF NOPIFEXISTINFILE'
Option.9  = 'DOX  DOIFEXIST DOANYWAY'
Option.10 = 'FF   FIRSTFOUND'
Option.11 = 'LF   LASTFOUND'
Option.12 = 'EF   EVERYFOUND'
Option.13 = 'ICR  IFNOTFOUNDCREATE'
Option.14 = 'WIT  WITH'
Option.15 = 'IN'
Option.16 = 'NOF  NOPIFNOTFOUND'
Attribs = 'IN AFTER BEFORE WITH AFT BEF WIT'
Types   = 'STRING LINE SECTION TOKEN'
C.Cmd     = ''
C.Type1   = ''
C.What.0  = 0
C.Option1 = ''
C.Attr    = ''
C.Type2   = ''
C.Search  = ''
C.Option2 = ''
SAVE.0    = 0
do queued(); pull; end
params = arg(1)
CFile = HandleParametersAndInputErrors(params)
if CFile <> '' then do
do while lines(CFile)
ll = linein(CFile)
queue ll
end
call stream CFile, 'c', 'close'
end
AlreadyRead = 0
do while queued() > 0
if AlreadyRead == 0 then parse pull OrgLine
AlreadyRead = 0
OrgLine = RemoveComment( OrgLine )
if OrgLine == '' then iterate
UppLine = translate( OrgLine )
Command = ValidCommand(word( Uppline, 1 ))
if Command <> '' then do
CommandLine = OrgLine
do while lines( CFile ) & substr(CommandLine, length(CommandLine)) == ','
parse pull OrgLine
OrgLine = RemoveComment( OrgLine )
if OrgLine == '' then iterate
UppLine = translate( OrgLine )
if OrgLine <> '' then do
CommandLine = CommandLine || OrgLine
end
end
/* say
say 'Original:' CommandLine */
C.Cmd     = ''
C.Type1   = ''
C.What.0  = 0
C.Option1 = ''
C.Attr    = ''
C.Type2   = ''
C.Search  = ''
C.Option2 = ''
select
when Command == 'OPEN' then do
C.Cmd = Command
if ParseFileCommand( CommandLine ) == 0 then do
ret = ValidateCommand()
if ret <> 0 then say ret ':' CommandLine
else ret = OpenClose('OPEN')
end
end
when Command == 'CLOSE' then do
C.Cmd = Command
if ParseFileCommand( CommandLine ) == 0 then do
ret = ValidateCommand()
if ret <> 0 then say ret ':' CommandLine
else ret = OpenClose('CLOSE')
end
end
when Command == 'ADD' then do
C.Cmd = Command
if ParseADDCommand( CommandLine ) == 0 then do
ret = ValidateCommand()
if ret <> 0 then say ret ':' CommandLine
else ret = Add()
end
end
when Command == 'DEL' then do
C.Cmd = Command
if ParseDRSCommand( CommandLine ) == 0 then do
ret = ValidateCommand()
if ret <> 0 then say ret ':' CommandLine
else ret = Delete()
end
end
when Command == 'REP' then do
C.Cmd = Command
if ParseDRSCommand( CommandLine ) == 0 then do
ret = ValidateCommand()
if ret <> 0 then say ret ':' CommandLine
else ret = Replace()
end
end
when Command == 'SAV' then do
C.Cmd = Command
if ParseDRSCommand( CommandLine ) == 0 then do
ret = ValidateCommand()
if ret <> 0 then say ret ':' CommandLine
else ret = Save()
end
end
when Command == 'REX' then do
C.Cmd = Command
if ParseREXXCommand( CommandLine ) == 0 then do
ret = ValidateCommand()
if ret <> 0 then say ret ':' CommandLine
else ret = Rexx()
end
end
otherwise NOP
end
end
else do
say Color.red||'invalid command:' word(UppLine,1)||Color.white
end
end
exit 0
AnalyseWhatString: procedure expose C. SAVE. Color.
cc = arg(1)
cc = strip( cc )
i = 1
C.What.1 = ''
do while substr(cc,1,1) == '"' | substr(cc,1,1) == ',' | translate(substr(cc,1,4)) == 'SAVE'
if substr( cc,1,1 ) == '"' then do
parse value cc with '"' token '"' cc
C.What.i = C.What.i || token
do while substr( cc,1,1 ) == '"'
parse value cc with '"' token '"' cc
C.What.i = C.What.i || '"' ||token
end
end
else if substr( cc,1,1 ) == ',' then do
i = i+1
C.What.i = ''
cc = substr( cc,2 )
end
else if substr( cc,1,4 ) == 'SAVE' then do
if SAVE.0 > 0 then do
if SAVE.1 <> '' then C.What.i = C.What.i || SAVE.1
do k = 2 to SAVE.0
i = i+1
C.What.i = SAVE.k
end
cc = substr( cc,5 )
end
end
cc = strip( cc )
end
C.What.0 = i
return cc
ParseADDCommand: procedure expose C. Option. SAVE. Color. Color.
cc = arg(1)
tmpc = cc
parse value cc with gagacmd cc
parse value cc with C.Type1 cc
C.Type1 = translate(C.Type1)
cc = AnalyseWhatString( cc )
cc = strip( cc )
if substr( cc,1,1 ) == '(' then parse value cc with '(' C.Option1 ')' cc
cc = strip( cc )
parse value cc with C.Attr C.Type2 cc
C.Attr  = translate(C.Attr)
C.Type2 = translate(C.Type2)
cc = strip( cc )
if lastpos(')',cc) == length(cc) then do
parse value substr(cc,lastpos('(',cc)) with '(' C.Option2 ')'
C.Search = strip(substr(cc,1,lastpos('(',cc)-1))
end
else C.Search = strip(cc)
if ValidateOption() == -1 then do
say Color.yellow||'unknown option or attribute in'||Color.white
say tmpc
end
return 0
ParseDRSCommand: procedure expose C. Attribs Option. SAVE. Color.
cc = arg(1)
tmpc = cc
parse value cc with gagacmd cc
parse value cc with C.Type1 cc
C.Type1 = translate(C.Type1)
cc = strip( cc )
tmpcc = cc
do while pos('"',tmpcc) >0
parse value tmpcc with tt1'"'id'"'tt2
tmpcc = tt1||copies('x',length(id)+2)||tt2
end
do i = 1 to words( Attribs )
pp = wordpos(word(Attribs,i),translate(tmpcc))
if pp >0 then do
pp = wordindex(tmpcc,pp)
part1 = strip(substr(cc,1,pp-1))
part2 = strip(substr(cc,pp))
leave
end
end
if pp == 0 then do
part1 = strip(cc)
part2 = ''
end
if length(part1) > 0 then do
if lastpos(')',part1) == length(part1) then do
parse value substr(part1,lastpos('(',part1)) with '(' C.Option1 ')'
C.What.1 = strip(substr(part1,1,lastpos('(',part1)-1))
end
else C.What.1 = strip(part1)
C.What.0 = 1
end
if length(part2) > 0 then do
parse value part2 with C.Attr C.Type2 part2
C.Attr  = translate(C.Attr)
C.Type2 = translate(C.Type2)
if lastpos(')',part2) == length(part2) then do
parse value substr(part2,lastpos('(',part2)) with '(' C.Option2 ')'
C.Search = strip(substr(part2,1,lastpos('(',part2)-1))
end
else C.Search = strip(part2)
end
if C.Cmd == 'REP' then do
tmp = C.Search
C.Search = C.What.1
if tmp <> '' then do
tmp = AnalyseWhatString( tmp )
end
end
if ValidateOption() == -1 then say Color.yellow||'unknown option in'||Color.white tmpc
return 0
ParseFileCommand: procedure expose C.
cc = arg(1)
parse value cc with gagacmd cc
parse value cc with C.What.1 cc
C.What.0 = 1
return 0
ParseREXXCommand: procedure expose C. SAVE.
cc = arg(1)
parse value cc with gagacmd cc
cc = AnalyseWhatString( cc )
return 0
Rexx: procedure expose C. Color.
RexxCommandLine_ = ''
do _i_ = 1 to C.What.0
RexxCommandLine_ = RexxCommandLine_ || ';' || C.What._i_
end
signal on SYNTAX  NAME interpretsyntaxerror
signal on ERROR   NAME interpretsyntaxerror
signal on FAILURE NAME interpretsyntaxerror
interpret RexxCommandLine_
signal off SYNTAX
return 0
interpretsyntaxerror:
say Color.red||'---> ERROR in REXX command to interprete'||Color.white
return -1
RemoveComment: procedure
line = arg(1)
AnyComment = pos('//',line)
if AnyComment <> 0 then line = substr(line,1,AnyComment-1)
if pos( '/*', line ) <> 0 then do
line = strip(substr(line,1,pos('/*',line)-1)) ||,
strip(substr(line,pos('*/',line)+2))
end
line = strip( line )
return line
ValidCommand: procedure expose Command. Color.
cc = arg(1)
do i = 1 to Command.0
if wordpos( cc, Command.i ) <> 0 then return word(Command.i,1)
end
return ''
OpenClose: procedure expose C. Line. CloseFileName Color.
command = strip(arg(1))
FileName = C.What.1
if C.Cmd == 'OPEN' then do
if stream(FileName,'c','query exists') <> '' then do
i=0
do while lines( FileName )
i=i+1
Line.i = linein( FileName )
end
Line.0 = i
call stream FileName, 'C', 'CLOSE'
CloseFileName = FileName
/* say '---> file read:' FileName */
end
else do
Line.0 = 0
CloseFileName = FileName
/* say '---> file does not exist, will be created when closing:' FileName */
return -1
end
end
else do
if FileName <> '' then CloseFileName = FileName
'@del' CloseFileName '1>NUL 2>NUL'
do i = 1 to Line.0
call lineout CloseFileName, Line.i
end
if stream(CloseFileName,'c','close') == 'READY:' then do
/* say '---> file successfully written:' CloseFileName */
end
else /* say Color.yellow||'---> file not written:'||Color.white CloseFileName */ NOP
end
return 0
Replace: procedure expose Line. LinesFound. C. Color.
Insert.0 = C.What.0
do i = 1 to Insert.0
Insert.i = C.What.i
end
select
when C.Type1 == 'STRING' then do
LS = C.Search || '*'
LS = insert( '*', LS, pos('"', LS)-1)
m = LookForLines( LS, C.Option1 )
if C.Option1 == 'FF' then do
snum = LookForStrings('ID', C.Search, COption1, LinesFound.1 )
if snum == 1 then do
k = LinesFound.1
Line.k = substr(Line.k,1,StringsFound.1.Start-1)||C.What.1||substr(Line.k,StringsFound.1.End+1)
/* say '---> string replaced in line nr.'k 'position' StringsFound.1.Start */
end
end
if C.Option1 == 'LF' then do
snum = LookForStrings('ID', C.Search, COption1, LinesFound.1 )
if snum == 1 then do
k = LinesFound.m
Line.k = substr(Line.k,1,StringsFound.snum.Start-1)||C.What.1||substr(Line.k,StringsFound.snum.End+1)
/* say '---> string replaced in line nr.'k 'position' StringsFound.snum.Start */
end
end
if C.Option1 == 'EF' then do
do i = m to 1 by -1
k = LinesFound.i
snum = LookForStrings('ID', C.Search, COption1, LinesFound.i )
do l = snum to 1 by -1
Line.k = substr(Line.k,1,StringsFound.l.Start-1)||C.What.1||substr(Line.k,StringsFound.l.End+1)
/* say '---> string replaced in line nr.'k 'position' StringsFound.l.Start */
end
end
end
end
when C.Type1 == 'LINE' then do
m = LookForLines( C.Search, C.Option1 )
do i = m to 1 by -1
call InsertLine LinesFound.i
call DeleteLine LinesFound.i, 1
/* say '---> replace line nr.'LinesFound.i */
end
if m == 0 then do
/* say Color.yellow||'---> target line not found:'||Color.white C.Search */
if pos('ICR ATB',C.Option1) > 0 then do
call InsertLine 0
/* say '---> insert line at begin' */
end
if pos('ICR ATE',C.Option1) > 0 then do
call InsertLine Line.0
/* say '---> insert line at end' */
end
end
end
when C.Type1 == 'SECTION' then do
snum = LookForSections( C.Search, C.Option1, 1 )
do i = snum to 1 by -1
call DeleteLine SectionsFound.i.Start, SectionsFound.i.End - SectionsFound.i.Start +1
call InsertLine SectionsFound.i.Start -1
/* say '---> replace section from line nr.'SectionsFound.i.Start 'to line nr.'SectionsFound.i.End */
end
if snum == 0 then do
/* say Color.yellow||'---> target section not found:'Color.white C.Search */
if pos('ICR ATB',C.Option1) > 0 then do
call InsertLine 0
/* say '---> insert section at begin' */
end
if pos('ICR ATE',C.Option1) > 0 then do
call InsertLine Line.0
/* say '---> insert section at end' */
end
end
end
otherwise NOP
end
return 0
Add: procedure expose Line. LinesFound. C. Color.
Insert.0 = C.What.0
do i = 1 to Insert.0
Insert.i = C.What.i
end
select
when C.Type1 == 'STRING' | C.Type1 == 'TOKEN' then do
lnum = LookForLines( C.Search, C.Option2 )
if lnum == 0 then do
/* say Color.yellow||'---> target line not found:'||Color.white C.Search '-->NOP' */
end
do i = lnum to 1 by -1
if C.Type1 == 'TOKEN' then do
cstring = ''
do o = 1 to C.What.0
cstring = cstring || C.What.o
end
end
else cstring = C.What.1
snum = LookForStrings('AS', cstring, 'FF', LinesFound.i )
if snum > 0 & pos('NOX',C.Option1) >0 then do
/* say '---> string/token already exists in line nr.'LinesFound.i '-->NOP' */
iterate i
end
if pos('ATB',C.Option1) >0 | pos('ATE',C.Option1) >0 then do
k = LinesFound.i
if pos('ATB',C.Option1) >0 then do
Line.k = cstring || Line.k
/* say '---> string/token inserted in line nr.'k */
end
if pos('ATE',C.Option1) >0 then do
if C.Type1 == 'TOKEN' then do
if C.What.0 > 1 & lastpos(C.What.2,Line.k) <> length(Line.k)
then Line.k = Line.k || C.What.2 || cstring
else Line.k = Line.k || cstring
/* say '---> token inserted in line nr.'k */
end
else do
Line.k = Line.k || cstring
/* say '---> string inserted in line nr.'k */
end
end
end
else do
if pos('AFT',C.Option1) >0 | pos('BEF',C.Option1) >0 then do
startpos = pos('"', C.Option1)
endpos   = lastpos('"',C.Option1)
if  startpos <> 0 then do
sstring = substr(C.Option1,startpos,endpos-startpos+1)
if translate(substr(C.Option1,startpos-1,1)) == 'C' then do
sstring = 'C' || sstring
startpos = startpos-1
end
end
else sstring = '""'
soption = ''
if pos(' FF',C.Option1) >0 then soption = 'FF'
if pos(' LF',C.Option1) >0 then soption = 'LF'
if pos(' EF',C.Option1) >0 then soption = 'EF'
if soption == '' then soption = 'FF'
tsum = LookForStrings('ID', sstring, soption, LinesFound.i )
if tsum == 0 then do
/* say Color.yellow||'---> string' sstring 'to insert after/before not found:'||Color.white */
end
k = LinesFound.i
if C.Type1 == 'STRING' then toinsert = C.What.1
else toinsert = C.What.1||C.What.2
do l = tsum to 1 by -1
if pos('AFT',C.Option1) >0 then do
Line.k = substr(Line.k,1,StringsFound.l.End)||toinsert||substr(Line.k,StringsFound.l.End+1)
/* say '---> string/token inserted in line nr.'k */
end
if pos('BEF',C.Option1) >0 then do
Line.k = substr(Line.k,1,StringsFound.l.Start-1)||toinsert||substr(Line.k,StringsFound.l.Start)
/* say '---> string/token inserted in line nr.'k */
end
end
end
end
end
end
when C.Type1 == 'LINE' | C.Type1 == 'SECTION' then do
select
when (C.Attr == 'AFT' | C.Attr == 'BEF') & (C.Type2 == 'LINE') then do
if pos('NOXF',C.Option1) > 0 then do
identical = 0
if C.Type1 == 'LINE' then do
do j = 1 to C.What.0
do k = 1 to Line.0
if translate(C.What.j) == translate(Line.k) then identical = identical +1
end
if identical == C.What.0 then do
/* say Color.yellow||'---> line(s) to insert already exist in the file (unsorted, uppercase compare) --> NOP'||Color.white */
return 0
end
end
end
else do
do k = 1 to Line.0
if translate(C.What.1) == translate(Line.k) then do
/* say Color.yellow||'---> name of section to insert already exist in the file (uppercase compare) --> NOP'||Color.white */
return 0
end
end
end
end
lnum = LookForLines( C.Search, C.Option2 )
do i = lnum to 1 by -1
if pos('NOX',C.Option1) > 0 then do
identical = 0
do j = 1 to C.What.0
if C.Attr == 'AFT' then do
index = LinesFound.i +j
if translate(C.What.j) == translate(Line.index) then identical = identical +1
end
if C.Attr == 'BEF' then do
index = LinesFound.i - C.What.0 -1 +j
if translate(C.What.j) == translate(Line.index) then identical = identical +1
end
end
if identical == C.What.0 then do
/* say Color.yellow||'---> line/section to insert already exist (uppercase compare) --> NOP'||Color.white */
iterate i
end
end
if C.Attr == 'AFT' then do
call InsertLine LinesFound.i
/* say '---> line/section inserted after line nr.'LinesFound.i */
end
if C.Attr == 'BEF' then do
call InsertLine LinesFound.i -1
/* say '---> line/section inserted before line nr.'LinesFound.i */
end
end
if lnum == 0 then do
/* say Color.yellow||'---> target line not found:'||Color.white C.Search */
if pos('ICR ATB',C.Option1) > 0 then do
call InsertLine 0
/* say '---> line/section inserted at begin of file' */
end
if pos('ICR ATE',C.Option1) > 0 then do
call InsertLine Line.0
/* say '---> line/section inserted at end of file' */
end
end
end
when C.Type1 == 'LINE' & C.Attr == 'IN'  & C.Type2 == 'SECTION' then do
snum = LookForSections( C.Search, C.Option2, 1 )
if snum == 0 then do
/* say Color.yellow||'---> target section not found:'||Color.white C.Search */
end
if snum == 0 & pos('NOF',C.Option2) == 0 then do
if pos('ICR ATB',C.Option2) >0 then insertat = 0
if pos('ICR ATE',C.Option2) >0 then insertat = Line.0
Insert.0 = 1;
parse value C.Search with '"'Insert.1'"'
call InsertLine insertat
/* say '---> create new section named:' Insert.1 */
Insert.0 = C.What.0
do i = 1 to Insert.0
Insert.i = C.What.i
end
snum = 1
SectionsFound.1.Start = insertat +1
SectionsFound.1.End   = insertat +1
end
do i = snum to 1 by -1
if pos('NOX',C.Option1) > 0 | pos('NOXS',C.Option1) > 0 then do
identical = 0
do j = 1 to C.What.0
do k = SectionsFound.i.Start to SectionsFound.i.End
if translate(C.What.j) == translate(Line.k) then identical = identical +1
end
end
if identical == C.What.0 then do
/* say '---> line(s) already exist in section (uppercase compare) --> NOP' */
iterate i
end
end
if pos('ATB',C.Option1) >0 then insertat = SectionsFound.i.Start
if pos('ATE',C.Option1) >0 then insertat = SectionsFound.i.End
call InsertLine insertat
/* say '---> insert line(s) at line nr.'insertat */
end
end
when C.Type1 == 'SECTION' & (C.Attr == 'AFT' |C.Attr == 'BEF')  & C.Type2 == 'SECTION' then do
snum = LookForSections( '"'C.What.1'"', 'FF', 1 )
if snum > 0 then do
if pos('NOX',C.Option1) > 0 | pos('NOXF',C.Option1) > 0 then do
/* say Color.yellow||'---> name of section to insert already exist in the file (uppercase compare) --> NOP'||Color.white */
end
if pos('DOX',C.Option1) > 0 then do
/* say Color.yellow||'---> section already exist'||Color.white */
end
end
if snum == 0 | pos('DOX',C.Option1) > 0 then do
snum = LookForSections( C.Search, C.Option2, 1 )
if snum == 0 & pos('NOF',C.Option2) == 0 then do
if pos('ICR ATB',C.Option1) >0 then insertat = 0
if pos('ICR ATE',C.Option1) >0 then insertat = Line.0
call InsertLine insertat
/* say '---> insert section at line nr.'insertat */
end
do i = snum to 1 by -1
if C.Attr == 'AFT' then do
call InsertLine SectionsFound.i.End
/* say '---> insert section at line nr.'SectionsFound.i.End */
end
if C.Attr == 'BEF' then do
call InsertLine SectionsFound.i.Start -1
/* say '---> insert section at line nr.'SectionsFound.i.Start -1 */
end
end
end
end
otherwise NOP
end
end
otherwise NOP
end
return 0
Delete: procedure expose Line. LinesFound. C. Color.
select
when C.Type1 == 'LINE' then do
select
when C.Attr == '' then do
m = LookForLines( C.What.1, C.Option1 )
if m == 0 then /* say Color.yellow||'---> target line not found:'||Color.white C.What.1 */ NOP
do i = m to 1 by -1
/* say '---> delete line nr.'LinesFound.i */
call DeleteLine LinesFound.i, 1
end
end
when C.Attr == 'BEF' & C.Type2 == 'LINE' then do
m = LookForLines( C.Search, C.Option2 )
if m == 0 then /* say Color.yellow||'---> target line not found:'||Color.white C.Search */ NOP
do i = m to 1 by -1
/* say '---> delete line nr.'LinesFound.i -1 */
call DeleteLine LinesFound.i -1, 1
end
end
when C.Attr == 'AFT'  & C.Type2 == 'LINE' then do
m = LookForLines( C.Search, C.Option2 )
if m == 0 then /* say Color.yellow||'---> target line not found:'||Color.white C.Search */ NOP
do i = m to 1 by -1
/* say '---> delete line nr.'LinesFound.i +1 */
call DeleteLine LinesFound.i +1, 1
end
end
when C.Attr == 'IN'     & C.Type2 == 'SECTION' then do
snum = LookForSections( C.Search, C.Option2, 1 )
if m == 0 then /* say Color.yellow||'---> target section not found:'||Color.white C.Search */ NOP
do i = snum to 1 by -1
lnum = LookForLines( C.What.1, C.Option1, SectionsFound.i.Start, SectionsFound.i.End )
if lnum == 0 then /* say Color.yellow||'---> target section not found:'||Color.white C.What.1 */ NOP
do j = lnum to 1 by -1
k = LinesFound.j
/* say '---> delete line nr.'LinesFound.j */
call DeleteLine LinesFound.j, 1
end
end
end
otherwise NOP
end
end
when C.Type1 == 'STRING' then do
select
when C.Attr == 'IN' & C.Type2 == 'LINE' then do
lnum = LookForLines( C.Search, C.Option2 )
if lnum == 0 then /* say Color.yellow||'---> target line not found:'||Color.white C.Search */ NOP
do i = 1 to lnum
snum = LookForStrings('ID', C.What.1, C.Option1, LinesFound.i )
if snum == 0 then /* say Color.yellow||'---> line' LinesFound.i': target string not found:'||Color.white C.What.1 */ NOP
do j = StringsFound.0 to 1 by -1
k = LinesFound.i
Line.k = substr(Line.k,1,StringsFound.j.Start-1) ||,
substr(Line.k,StringsFound.j.End+1)
/* say '---> delete string in line nr.'k */
end
end
end
otherwise NOP
end
end
when C.Type1 == 'SECTION' then do
select
when C.Attr == '' then do
snum = LookForSections( C.What.1, C.Option1, 1 )
if snum == 0 then /* say Color.yellow||'---> target section not found:'||Color.white C.What.1 */ NOP
do i = snum to 1 by -1
call DeleteLine SectionsFound.i.Start, SectionsFound.i.End - SectionsFound.i.Start +1
/* say '---> delete section from line nr.'SectionsFound.i.Start 'to line nr.'SectionsFound.i.End */
end
end
when C.Type2 == 'SECTION' then do
snum = LookForSections( C.Search, C.Option2, 1 )
if snum == 0 then /* say Color.yellow||'---> target section not found:'||Color.white C.Search */ NOP
found.0 = snum
do i = snum to 1 by -1
found.i.start = SectionsFound.i.Start
found.i.end   = SectionsFound.i.End
end
if C.Attr == 'AFT' then do
do i = snum to 1 by -1
mm = LookForSections( '"["*', 'FF', found.i.end +1 )
if mm > 0 then do
call DeleteLine SectionsFound.1.Start, SectionsFound.1.End - SectionsFound.1.Start +1
/* say '---> delete section from line nr.'SectionsFound.1.Start 'to line nr.'SectionsFound.1.End */
end
end
end
if C.Attr == 'BEF' then do
do i = snum to 1 by -1
mm = LookForSections( '"["*', 'LF', 1, found.i.start -1 )
if mm > 0 then call DeleteLine SectionsFound.1.Start, SectionsFound.1.End - SectionsFound.1.Start +1
/* say '---> delete section from line nr.'SectionsFound.1.Start 'to line nr.'SectionsFound.1.End */
end
end
end
otherwise NOP
end
end
otherwise NOP
end
return 0
Save: procedure expose Line. C. SAVE. Color.
select
when C.Type1 == 'LINE' then do
m = LookForLines( C.What.1, C.Option1 )
if m > 0 then do
j = LinesFound.1
SAVE.1 = Line.j
SAVE.0 = 1
/* say '---> save line nr.'j */
end
else do
/* say Color.yellow||'---> target line not found:'||Color.white C.What.1 */
end
end
when C.Type1 == 'SECTION' then do
snum = LookForSections( C.What.1, C.Option1, 1 )
if snum > 0 then do
j = 0
do i = SectionsFound.1.Start to SectionsFound.1.End
j = j+1
SAVE.j = Line.i
end
SAVE.0 = j
/* say '---> save section from linemr.'SectionsFound.1.Start 'to line nr.'SectionsFound.1.End */
end
else do
/* say Color.yellow||'---> target section not found:'||Color.white C.What.1 */
end
end
otherwise NOP
end
return 0
LookForStrings: procedure expose C. Line. StringsFound. Color.
type   = arg(1)
ss     = arg(2)
option = arg(3)
lnum   = arg(4)
CaseSens  = 0
ssupper = translate(ss)
if type == 'ID' then do
if pos('C',ssupper) == 1 then CaseSens  = 1
if CaseSens  == 1 then ss = substr(ss,2)
end
if type == 'ID' then do
i = 0
do while length(ss) > 0
ss = strip(ss)
i = i+1
if substr(ss,1,1) == '*' then do
ss.i = '*'
parse value ss with '*'ss
end
else do
parse value ss with '"'ss.i'"' ss
do while substr(ss,1,1) == '"'
parse value ss with '"'tmp'"' ss
ss.i = ss.i || '"' || tmp
end
end
end
ss.0 = i
end
else do
ss.0 = 1
ss.1 = ss
end
if CaseSens == 0 then do
do i = 1 to ss.0
ss.i = translate( ss.i )
end
end
if ss.0 > 1 | ss.0 == 0 then do
say Color.red||'invalid search string (several lines not possible)'||Color.white
return 0
end
ss = ss.1
if CaseSens  == 0 then ss = translate(ss)
tmpline = Line.lnum
if CaseSens == 0 then tmpline = translate( tmpline )
found = 0
sstart = 1
do while pos(ss,tmpline,sstart) > 0 & sstart <= length( tmpline )
found = found+1
StringsFound.found.Start = pos(ss,tmpline,sstart)
StringsFound.found.End   = StringsFound.found.Start + length(ss) -1
sstart = StringsFound.found.End + 1
end
StringsFound.0 = found
if StringsFound.0 > 0 then do
if pos('LF',option) > 0 then do
k = StringsFound.0
StringsFound.1.Start = StringsFound.k.Start
StringsFound.1.End   = StringsFound.k.End
StringsFound.0 = 1
end
if pos('FF',option) > 0 then do
StringsFound.0 = 1
end
end
return StringsFound.0
DeleteLine: procedure expose Line.
parse arg number, count
if number = 0 then return
if number > Line.0 then return
if number = Line.0 then do
Line.0 = Line.0 -1
return
end
do i = number to Line.0 - count
j = i + count
Line.i = Line.j
end
Line.0 = Line.0 - count
return
InsertLine: procedure expose Line. Insert.
parse arg where
if Insert.0 = 0 then return
if where > Line.0 then return
tindex = Line.0 + Insert.0
sindex = Line.0
do i = Line.0 to where by -1
Line.tindex = Line.sindex
tindex = tindex-1
sindex = sindex-1
end
j=1
do i = where+1 to where+Insert.0
Line.i = Insert.j
j = j+1
end
Line.0 = Line.0 + Insert.0
return
LookForSections: procedure expose Line. LinesFound. C. SectionsFound.
search = arg(1)
option = arg(2)
sstart = arg(3)
send   = arg(4)
SectionsFound.0 = 0
if sstart == '' then sstart = 1
if send   == '' then send   = Line.0
special = ''
if translate( search ) == 'FIRST' then do
search = '"["*'
special = 'FIRST'
end
if translate( search ) == 'LAST' then do
search = '"["*'
option = 'EF'
special = 'LAST'
end
if datatype( search ) == 'NUM' then do
special = search
search = '"["*'
option = 'EF'
end
SectionID = '['
SectionsFound.0 = LookForLines( search, option, sstart, send )
if SectionsFound.0 == 0 then return 0
do i = 1 to SectionsFound.0
SectionsFound.i.Start = LinesFound.i
do j = SectionsFound.i.Start + 1 to Line.0
if j == Line.0 then do
SectionsFound.i.End = j
iterate i
end
else if substr(strip(Line.j),1,1) == SectionID then do
SectionsFound.i.End = j-1
k = j-1
do while Line.k == ''
SectionsFound.i.End = k-1
k = k-1
end
iterate i
end
end
end
if special = 'FIRST' & SectionsFound.0 > 0 then SectionsFound.0 = 1
if special = 'LAST'  & SectionsFound.0 > 0 then do
j = SectionsFound.0
SectionsFound.1.Start = SectionsFound.j.Start
SectionsFound.1.End   = SectionsFound.j.End
SectionsFound.0 = 1
end
if datatype( special ) == 'NUM' & SectionsFound.0 > 0 then do
j = special
SectionsFound.1.Start = SectionsFound.j.Start
SectionsFound.1.End   = SectionsFound.j.End
SectionsFound.0 = 1
end
return SectionsFound.0
LookForLines: procedure expose Line. LinesFound.
ss     = arg(1)
op     = arg(2)
sstart = arg(3)
send   = arg(4)
if sstart == '' then sstart = 1
if send   == '' then send   = Line.0
LinesFound.0 = 0
if translate(ss) == 'FIRST' then do
if Line.0 > 0 then do
LinesFound.0 = 1
LinesFound.1 = 1
return 1
end
else return 0
end
if translate(ss) == 'LAST' then do
LinesFound.0 = 1
LinesFound.1 = Line.0
return 1
end
if datatype(ss) == 'NUM' then do
LinesFound.0 = 1
LinesFound.1 = strip(ss)
return 1
end
CaseSens  = 0
LineStrip = 0
ssupper = translate(ss)
if pos('C',ssupper) == 1 | (pos('C',ssupper) == 2 & pos('S',ssupper) == 1) then CaseSens  = 1
if pos('S',ssupper) == 1 | (pos('S',ssupper) == 2 & pos('C',ssupper) == 1) then LineStrip = 1
if CaseSens  == 1 then ss = substr(ss,2)
if LineStrip == 1 then ss = substr(ss,2)
i = 0
do while length(ss) > 0
ss = strip(ss)
i = i+1
if substr(ss,1,1) == '*' then do
ss.i = '*'
parse value ss with '*'ss
end
else do
parse value ss with '"'ss.i'"' ss
do while substr(ss,1,1) == '"'
parse value ss with '"'tmp'"' ss
ss.i = ss.i || '"' || tmp
end
end
end
ss.0 = i
if CaseSens == 0 then do
do i = 1 to ss.0
ss.i = translate( ss.i )
end
end
k = 0
do i = sstart to send
tmpline = Line.i
if LineStrip == 1 then tmpline = strip( tmpline )
if CaseSens  == 0 then tmpline = translate( tmpline )
startpos = 1
wildcard = 0
do j = 1 to ss.0
if ss.j == '*' then wildcard = 1
else do
foundpos = pos(ss.j,tmpline,startpos)
if foundpos == 0 then do
iterate i
end
else do
if wildcard == 1 then do
if foundpos < startpos then iterate i
end
else do
if foundpos <> startpos then iterate i
end
startpos = foundpos + length(ss.j)
end
wildcard = 0
end
end
if wildcard == 0 then do
j = ss.0
foundpos = lastpos(ss.j,tmpline)
if foundpos + length(ss.j) -1  == length(tmpline) then matchingend = 1
else matchingend = 0
end
if (wildcard == 1) | (matchingend == 1) then do
k = k+1
LinesFound.k = i
if pos('FF',op) > 0 then leave
end
end
LinesFound.0 = k
if pos('LF',op) > 0 & k > 0 then do
LinesFound.1 = LinesFound.k
LinesFound.0 = 1
end
return LinesFound.0
ValidateOption: procedure expose C. Option.
C.Option1    = CheckOption(C.Option1)
if C.Option1 == -1 then return -1
C.Option2    = CheckOption(C.Option2)
if C.Option2 == -1 then return -1
C.Attr       = CheckOption(C.Attr)
if C.Attr    == -1 then return -1
return ''
CheckOption: procedure expose Option. Color.
popt = arg(1)
startpos = pos('"', popt)
endpos   = lastpos('"',popt)
if  startpos <> 0 then do
endpos = lastpos( '"',popt)
string = substr(popt,startpos,endpos-startpos+1)
if translate(substr(popt,startpos-1,1)) == 'C' then do
string = 'C' || string
startpos = startpos-1
end
popt = substr(popt,1,startpos-1) '$ID$' substr(popt,endpos+1)
end
else string = ''
i = 0
do while pos(',',popt) <> 0
i = i+1
parse value popt with opt.i ',' popt
popt  = strip(popt)
end
if popt <> '' then do
i = i+1
opt.i = popt
end
opt.0 = i
do i = 1 to opt.0
tmpo = ''
do k = 1 to words(opt.i)
ooo = translate(word(opt.i,k))
if strip(ooo) == '$ID$' then do
tmpo = tmpo string
found = 1
leave
end
found = 0
do j = 1 to Option.0
if wordpos(ooo,Option.j) <> 0 then do
tmpo = tmpo word(Option.j,1)
found = 1
leave
end
end
if found == 0 then return -1
end
opt.i = strip(tmpo)
end
tmp = ''
do i = 1 to opt.0
if tmp <> '' then tmp = tmp','
tmp = tmp||opt.i
end
return tmp
ValidateCommand: procedure expose C. Color.
val.1  = ''
val.2  = ''
val.3  = 'DEL STRING   id    [FF|LF|EF]                                                  IN     LINE     id  [FF|LF|EF]'
val.4  = 'DEL LINE     id    [FF|LF|EF]                                                  -      -        -   -'
val.5  = 'DEL LINE      -    -                                                           BEF    LINE     id  [FF|LF|EF]'
val.6  = 'DEL LINE      -    -                                                           AFT    LINE     id  [FF|LF|EF]'
val.7  = 'DEL LINE     id    [FF|LF|EF]                                                  IN     SECTION  id  [FF|LF|EF]'
val.8  = 'DEL SECTION  id    [FF|LF|EF]                                                  -      -        -   -'
val.9  = 'DEL SECTION   -    -                                                           AFT    SECTION  id  [FF|LF|EF]'
val.10 = 'DEL SECTION   -    -                                                           BEF    SECTION  id  [FF|LF|EF]'
val.11 = 'ADD STRING    a    [ATB|ATE|AFT [FF|LF|EF] id|BEF [FF|LF|EF] id],[NOX|DOX]     IN     LINE     id  [FF|LF|EF]'
val.12 = 'ADD TOKEN     a    [ATB|ATE|AFT [FF|LF|EF] id|BEF [FF|LF|EF] id],[NOX|DOX]     IN     LINE     id  [FF|LF|EF]'
val.13 = 'ADD LINE      a    [NOX|NOXF|DOX],[ICR ATB|ICR ATE|NOF]                        AFT    LINE     id  [FF|LF|EF]'
val.14 = 'ADD LINE      a    [NOX|NOXF|DOX],[ICR ATB|ICR ATE|NOF]                        BEF    LINE     id  [FF|LF|EF]'
val.15 = 'ADD LINE      a    [ATB|ATE],[NOX|NOXS|DOX]                                    IN     SECTION  id  [FF|LF|EF],[ICR ATB|ICR ATE|NOF]'
val.16 = 'ADD SECTION   a    [NOX|NOXF|DOX],[ICR ATB|ICR ATE|NOF]                        AFT    LINE     id  [FF|LF|EF]'
val.17 = 'ADD SECTION   a    [NOX|NOXF|DOX],[ICR ATB|ICR ATE|NOF]                        BEF    LINE     id  [FF|LF|EF]'
val.18 = 'ADD SECTION   a    [NOX|NOXF|DOX],[ICR ATB|ICR ATE|NOF]                        AFT    SECTION  id  [FF|LF|EF],[NOF]'
val.19 = 'ADD SECTION   a    [NOX|NOXF|DOX],[ICR ATB|ICR ATE|NOF]                        BEF    SECTION  id  [FF|LF|EF],[NOF]'
val.20 = 'REP STRING   id    [FF|LF|EF]                                                  WIT    STRING   a   -'
val.21 = 'REP LINE     id    [FF|LF|EF],[ICR ATB|ICR ATE|NOF]                            WIT    LINE     a   -'
val.22 = 'REP SECTION  id    [FF|LF|EF],[ICR ATB|ICR ATE|NOF]                            WIT    SECTION  a   -'
val.23 = 'SAV LINE     id    [FF|LF]                                                     -      -        -   -'
val.24 = 'SAV SECTION  id    [FF|LF]                                                     -      -        -   -'
val.25 = 'OPEN         id    -                                                           -      -        -   -'
val.26 = 'CLOSE        id    -                                                           -      -        -   -'
val.27 = 'REX          a     -                                                           -      -        -   -'
val.0  = 27
def.1  = ''
def.2  = ''
def.3  = '                   FF                                                                              FF'
def.4  = '                   FF                                                                              -'
def.5  = '                   -                                                                               FF'
def.6  = '                   -                                                                               FF'
def.7  = '                   FF                                                                              FF'
def.8  = '                   FF                                                                              -'
def.9  = '                   -                                                                               FF'
def.10 = '                   -                                                                               FF'
def.11 = '                   ATE,NOX                                                                         FF'
def.12 = '                   ATE,NOX                                                                         FF'
def.13 = '                   NOX,NOF                                                                         FF'
def.14 = '                   NOX,NOF                                                                         FF'
def.15 = '                   ATE,NOX                                                                         FF,ICR ATB'
def.16 = '                   NOX,NOF                                                                         FF'
def.17 = '                   NOX,NOF                                                                         FF'
def.18 = '                   NOX,NOF                                                                         FF,NOF'
def.19 = '                   NOX,NOF                                                                         FF,NOF'
def.20 = '                   FF'
def.21 = '                   FF,NOF                                                                          -'
def.22 = '                   FF,NOF                                                                          -'
def.23 = '                   FF                                                                              -'
def.24 = '                   FF                                                                              -'
def.25 = '                   -                                                                               -'
def.26 = '                   -                                                                               -'
def.27 = '                   -                                                                               -'
def.0  = 27
if C.Cmd == 'OPEN' | C.Cmd == 'CLOSE' then do
if C.What.0 = 1 then return 0
else return 'no file name specified'
end
if C.Cmd == 'REX' then do
if C.What.0 > 0 then return 0
else return 'no REXX code specified'
end
res.0 = 0
j     = 0
do i = 1 to val.0
if C.Cmd == word(val.i,1) & C.Type1 == word(val.i,2) then do
j = j+1
res.j = i
end
end
res.0 = j
if j == 0 then do
return 'invalid type:' C.Type1
end
ok = 0
do i = 1 to res.0
j = res.i
if (C.Attr  == word(substr(val.j,80),1) &,
C.Type2 == word(substr(val.j,87),1)) |,
((C.Attr  == '' & word(substr(val.j,80),1) == '-') &,
(C.Type2 == '' & word(substr(val.j,87),1) == '-'))
then do
ok = 1
foundval = val.j
founddef = def.j
end
end
if ok == 0 then do
return 'invalid attribute or type:' C.Attr C.Type2
end
if word(foundval,3) == '-' & C.What.0 <> 0 then return 'invalid id string 1:' C.What.1
if substr(foundval,96,1) == '-' & C.Search <> '' then return 'invalid id string 2:' C.Search
C.Option1 = AnalyseOptionAndSetDefault( C.Option1, substr(foundval,20,60),  strip(substr(founddef,20,60)))
if C.Option1 == -1 then return 'invalid option 1'
C.Option2 = AnalyseOptionAndSetDefault( C.Option2, substr(foundval,100,60), strip(substr(founddef,100,60)))
if C.Option2 == -1 then return 'invalid option 2'
ssss = ''; do i=1 to C.What.0; if ssss=='' then ssss=C.What.i;else ssss=ssss||',' C.What.i; end
if C.Cmd == 'REP'
then /* say 'Parsed  :' C.Cmd C.Type1 C.Search       '('||C.Option1||')' C.Attr C.Type2 '"'||ssss||'"' '('||C.Option2||')' */ NOP
else /* say 'Parsed  :' C.Cmd C.Type1 '"'||ssss||'"' '('||C.Option1||')' C.Attr C.Type2 C.Search '('||C.Option2||')' */ NOP
return 0
AnalyseOptionAndSetDefault: procedure
orgopt = arg(1)
refopt = arg(2)
defopt = arg(3)
opt = orgopt
if opt == '' & RefOpt <> '-' then return defopt
startpos = pos('"', opt)
endpos   = lastpos('"',opt)
if  startpos <> 0 then do
endpos = lastpos( '"',opt)
string = substr(opt,startpos,endpos-startpos+1)
if translate(substr(opt,startpos-1,1)) == 'C' then do
string = 'C' || string
startpos = startpos-1
end
opt = substr(opt,1,startpos-1) 'id' substr(opt,endpos+1)
end
else string = ''
i = 0; do while refopt <> ''; i = i+1; parse value refopt with refopt.i','refopt; end; refopt.0 = i
i = 0; do while defopt <> ''; i = i+1; parse value defopt with defopt.i','defopt; end; defopt.0 = i
i = 0; do while opt    <> ''; i = i+1; parse value opt    with opt.i','opt;       end; opt.0    = i
do i = 1 to opt.0
found = 0
do j = 1 to refopt.0
if OptionStringMatch( opt.i, refopt.j ) <> 0 then do
found = 1
defopt.j = ''
iterate i
end
end
if found == 0 then do
return -1
end
end
do i = 1 to defopt.0
if defopt.i <> '' & defopt.i <> '-' then orgopt = orgopt','defopt.i
end
return orgopt
OptionStringMatch: procedure
str1 = arg(1)
str2 = arg(2)
do i = 1 to words(str1)
pp = pos(word(str1,i),str2)
if pp == 0 then return 0
else do
str2 = substr(str2,pp+length(word(str1,i)))
end
end
return pp
HandleParametersAndInputErrors: procedure
args = strip(arg(1))
if args == '' then do
call Usage
exit -1
end
if words(args) == 1 then do
filename = word(args,1)
if stream(filename,'c','query exists') == '' then do
call usage
exit -1
end
else return filename
end
else do
queue 'OPEN' word(args,1)
queue subword(args,2)
queue 'CLOSE' word(args,1)
end
return ''
Usage: procedure
say 'Illegal call to MODIFY'
say
say 'Usage:  Modify <commandfile>                  all commands in the file'
say '        Modify <filename>    <command>        command line version'
return 0
Logo: procedure
return 0
parse source . . srcname
call SysFileTree srcname, 'file', 'FT'
parse value(file.1) with yy'/'mm'/'dd'/'hh'/'ii .
sfile.1 = subword(sfile.1,1,2)
lastchange = 'This program was last changed on' dd'.'mm'.19'yy hh':'ii
title = 'MODIFY Ver. 1.1                                    S.Suter IBM, 04.08.1996'
say ''copies('',length(title)+2)''
say '' title ''
say '' right(lastchange,length(title)) ''
say ''copies('',length(title)+2)''
return 0
