/* upgradepkg - upgrade an already installed pkg */
/* Michael Zolk 2001                             */

call RxFuncAdd 'SysLoadFuncs','RexxUtil','SysLoadFuncs'
call SysLoadFuncs

call RxFuncAdd 'UX2LoadFuncs','UX2Util','UX2LoadFuncs'
call UX2LoadFuncs

if arg()=0 then
do
   call usage
   exit 1
end

if words(arg(1)) \= 1 then
do
   call usage
   exit 1
end

pkgname=arg(1)

/* test if pkgname is installed */
pkginfof=UX2Canonicalize("/var/log/packages/"pkgname)
if UX2FileExists(pkginfof)=0 then
do
  say "No such package: "pkginfof". Can't upgrade."
  exit 1
end

/* search new pkg in current dir */
newpkg=pkgname||".zip"
curdir=directory()
if UX2FileExists(curdir"\"newpkg)=0 then
do
   say "Cannot find new package "curdir"\"newpkg
   exit 1
end

/* remove everything except CONFFILES */
"@cmd /c removepkg -u "pkgname

/* install new pkg */
"@cmd /c installpkg -u "newpkg

exit

usage: procedure
say "upgradepkg - upgrade an UnixOS/2 package"
say ""
say "Usage: upgradepkg pkgname"
say ""
say "pkgname.zip has to be in the current directory"
return


