/**/
call RxFuncAdd "SysLoadFuncs","REXXUTIL","SysLoadFuncs"
call SysLoadFuncs
call RxFuncAdd "UX2LoadFuncs","UX2UTIL","UX2LoadFuncs"
call UX2LoadFuncs
say "UX2 Utilities loaded"

say "Version number is "UX2GetVersion()
say "My PID is "UX2Pid()
say "My PPID is "UX2PPid()
say "Unixroot is "UX2UnixRoot()
say ""
t = UX2BaseName("g:\test\test.exe")
say 'UX2BaseName("g:\test\test.exe") is "'t'"'
t = UX2BaseName("g:\test\test.exe",".exe")
say 'UX2BaseName("g:\test\test.exe",".exe") is "'t'"'
t = UX2BaseName("/test/test.exe",".exe")
say 'UX2BaseName("/test/test.exe",".exe") is "'t'"'
t = UX2BaseName("/foo/")
say 'UX2BaseName("/foo/") is "'t'"'
t = UX2BaseName("test.c")
say 'UX2BaseName("test.c") is "'t'"'
say ""
t = UX2DirName("g:\foo\bar\test.c")
say 'UX2DirName("g:\foo\bar\test.c") is "'t'"'
t = UX2DirName("/foo\bar/test.c")
say 'UX2DirName("/foo/bar/test.c") is "'t'"'
t = UX2DirName("test.c")
say 'UX2DirName("test.c") is "'t'"'
say ""
t = UX2Canonicalize("..\aa\bb")
say 'UX2Canonicalize("..\aa\bb") is "'t'" (current dir is "'directory()'")'
t = UX2Canonicalize("/usr/src/foo")
say 'UX2Canonicalize("/usr/src/foo") is "'t'"'
say ""
t = UX2UnixName("..\aa\bb")
say 'UX2UnixName("..\aa\bb") is "'t'"'
t = UX2UnixName("/usr/src/foo")
say 'UX2UnixName("/usr/src/foo") is "'t'"'
t = UX2UnixName("d:/usr\src")
say 'UX2UnixName("d:/usr\src") is "'t'"'
say ""
call UX2Umask("027")
say 'My Umask is now 'UX2Umask()
call UX2Uid("13")
call UX2Gid("42")
say 'My Uid/Gid is now 'UX2Uid()'/'UX2Gid()
say ""

say "Testing inode of an existing file"
rc = UX2Chmod("dlltest.cmd","0777")
say 'UX2Chmod("dlltest.cmd","0777") returns 'rc
say 'UX2Chown("dlltest.cmd") returns uid='UX2Chown("dlltest.cmd")
say 'UX2Chgrp("dlltest.cmd") returns gid='UX2Chgrp("dlltest.cmd")
say 'UX2Chmod("dlltest.cmd") returns mode='UX2Chmod("dlltest.cmd")' (note: umask!)'
say ""
say "Testing inode of a newly created file"
call SysFileDelete "testfile"
call lineout "testfile","testfile",1
call lineout "testfile"
say 'UX2Chown("testfile") returns uid='UX2Chown("testfile")
say 'UX2Chgrp("testfile") returns gid='UX2Chgrp("testfile")
say 'UX2Chmod("testfile") returns mode='UX2Chmod("testfile")' (note: umask!)'

say ""
call SysFileDelete "softlink"
call UX2MkSymLink "softlink","../setup/dlltest.cmd"
if UX2IsSymLink("softlink") = "1" then
  call whatis "softlink"
else
  say 'Error: failed to create symlink "softlink" correctly'

say ""
call SysFileDelete "chardev"
call SysFileDelete "blkdev"
rc = UX2Mknod("chardev","c",4,15)
say 'UX2Mknod("chardev","c",4,15) returns 'rc
rc = UX2Mknod("blkdev","b",4,17)
say 'UX2Mknod("blkdev","b",4,17) returns 'rc
if UX2IsCharDev('chardev') = "1" then
  say '"chardev" is a character device with major='UX2DevMajor("chardev")' and minor='UX2DevMinor("chardev")
else
  say 'Error: failed to create "chardev" correctly'

if UX2IsBlkDev('blkdev') = "1" then
  say '"blkdev" is a block device with major='UX2DevMajor("blkdev")' and minor='UX2DevMinor("blkdev")
else
  say 'Error: failed to create "blkdev" correctly'

if UX2IsCharDev("dlltest.cmd") = "0" then
  say '"dlltest.cmd" is not a character device, that is okay'
else 
  say 'Error: failed to identify chardev correctly, read "dlltest.cmd" as one'

say ""
call whatis "dlltest.cmd"
call whatis "chardev"
call whatis "blkdev"
call whatis "testfile"
call whatis "softlink"

exit

whatis: procedure
  parse arg file
  if UX2IsFile(file) = 1 then
    say '"'file'" is a regular FILE'
  if UX2IsDir(file) = 1 then
    say '"'file'" is a regular DIRECTORY'
  if UX2IsSymLink(file) = 1 then
    say '"'file'" is a SYMLINK pointing to "'UX2ReadSymLink(file)'"'
  if UX2IsCharDev(file) = 1 then
    say '"'file'" is a CHAR DEVICE'
  if UX2IsBlkDev(file) = 1 then
    say '"'file'" is a BLOCK DEVICE'
  return